//  -*- Mode: C++; -*-

// Copyright (c) 1993 Siemens Corporate Research, Inc.
// All rights reserved.
//
// $Author: bnell $
// $Date: 1996/12/18 15:46:14 $
// $Source: /home/yugo/kwuftn/CVS-repository/scheme-interface/scheme-types.cc,v $
// $Revision: 1.2 $
//

#include "scheme-types.h"

// stick something in here.

char scheme_convert(SCM s, char*)
{
  return scheme::to_char(s);
}

unsigned char scheme_convert(SCM s, unsigned char*)
{
  return scheme::to_char(s);
}

short scheme_convert(SCM s, short*)
{
  return scheme::to_long(s);
}

unsigned short scheme_convert(SCM s, unsigned short*)
{
  return scheme::to_ulong(s);
}

int scheme_convert(SCM s, int*)
{
  return scheme::to_long(s);
}

unsigned int scheme_convert(SCM s, unsigned int*)
{
  return scheme::to_ulong(s);
}

long scheme_convert(SCM s, long*)
{
  return scheme::to_long(s);
}

unsigned long scheme_convert(SCM s, unsigned long*)
{
  return scheme::to_ulong(s);
}

float scheme_convert(SCM s, float*)
{
  return scheme::to_double(s);
}

double scheme_convert(SCM s, double*)
{
  return scheme::to_double(s);
}

long double scheme_convert(SCM s, long double*)
{
  return scheme::to_double(s);
}

scheme_string scheme_convert(SCM s, scheme_string*)
{
  return scheme_string(s);
}

scheme_tmp_string scheme_convert(SCM s, scheme_tmp_string*)
{
  return scheme_string(s);
}

char* scheme_convert(SCM s, char**)
{
  return scheme::to_string(s);
}
