//  -*- Mode: C++; -*-

// Copyright (c) 1993 Siemens Corporate Research, Inc.
// All rights reserved.
//
// $Author: bnell $
// $Date: 1996/12/18 15:46:20 $
// $Source: /home/yugo/kwuftn/CVS-repository/scheme-interface/scheme_vec0.c,v $
// $Revision: 1.2 $
//

#ifndef __GNUG__
#include "scheme_vec0.h"
#endif

template <class T>
scheme_vec0<T>::scheme_vec0()
{
}

template <class T>
scheme_vec0<T>::scheme_vec0(T* vec)
: scheme_vec<T>(vec)
{
  unsigned int len = 0;
  while((int)*vec)
    vec++;
  set_length(len);
}

template <class T>
scheme_vec0<T>::scheme_vec0(const scheme_vec0<T>& vec)
: scheme_vec<T>(new T[vec.length() + 1], vec.length())
{
  for(unsigned int i = 0; i < length(); i++)
    value()[i] = vec.value()[i];
  value()[length()] = (T)0;
}

template <class T>
scheme_vec0<T>::scheme_vec0(SCM s)
: scheme_vec<T>(new T[scheme::obj_length(s) + 1], scheme::obj_length(s))
{
  for(unsigned int i = 0; i < length(); i++)
    value()[i] = scheme_convert(scheme::vref(s, i), (T*)0);
  value()[length()] = (T)0;
}
