/* IluJava_IluInit.c */
/* Chris Jacobi, December 13, 1996 9:50 pm PST */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */
 
/* 
 * $Id: IluJava_IluInit.c,v 1.5 1996/12/14 06:13:14 jacobi Exp $ 
 *
 *
 * See IluInit.java, IluInit2.java
 */


#include "IluJava.h"
#include "xerox_ilu_IluInit2.h"

/* ------------------------------------------------------------------
 * Main initialization 
 */
 
#define DEBUGGINGTHIS 0
#define DEBUGPRINT(x) if (DEBUGGINGTHIS) \
    ilu_DebugPrintf("$ IluJava_IluInit2 " x "\n");

EXPORTJAVA void
xerox_ilu_IluInit2_initializeLibrary(
	struct Hxerox_ilu_IluInit2 * unused
	)
{
    DEBUGPRINT("start");
    _ilujava_LockTechInit(); /*ilu wants this early*/
    DEBUGPRINT("did LT");
    _ilujava_WaitTechInit();
    DEBUGPRINT("did WT");
    _ilujava_AlarmTechInit();
    DEBUGPRINT("did AT");
    _ilujava_IluRt0InitHashTable();
    DEBUGPRINT("did HT");
    _ilujava_PassportInit();
    DEBUGPRINT("did PI");
    _ilujava_IluOIntInit();
    DEBUGPRINT("done");
}



