/* IluObject0.java */
/* Chris Jacobi, January 3, 1997 2:15 pm PST */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */
 
/* 
 * $Id: IluObject0.java,v 1.3 1997/01/03 22:30:41 jacobi Exp $ 
 */

package xerox.ilu;

/**
 * Generic, client visible super class interface.<p>
 * Super-class of omg.corba.corba_Object<p>
 *
 * Whenever accepting an object we recommend accepting an IluObject0
 * NEVER generate IluObject0 directly; generate objects
 * implementing the IluObject subclass instead.
 * (All Ilu routines do a run time check!)
 *
 * @see IluObject
 */
public interface IluObject0 {
}
