/* IluRuntimeError.java */
/* Chris Jacobi, November 27, 1996 12:15 pm PST */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */
 
/* $Id: IluRuntimeError.java,v 1.3 1996/11/27 20:23:22 jacobi Exp $ */
 

package xerox.ilu;

/**
 * IluRuntimeError is a handy superclass of Exception.<p>
 * IluRuntimeError's do not need to be declared in the throws 
 * clause (and is actually a RuntimeException, not an error).
 *
 *
 * @author Chris Jacobi
 */
public
class IluRuntimeError extends omg.corba.corba_RuntimeException {
    public IluRuntimeError() {
	super();
    }
    public IluRuntimeError(String s) {
	super(s);
    }
    public IluRuntimeError(String s, Throwable causedBy) {
	super(s, causedBy);
    }
} //IluRuntimeError


