/* omg.corba.corba_ServantFinalizable.java */
/* Chris Jacobi, January 7, 1997 2:29 pm PST */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */
 
/* $Id: corba_ServantFinalizable.java,v 1.1 1997/01/07 22:32:20 jacobi Exp $ */
 
package omg.corba;

/**
 * A server object can implement this interface to
 * request a call of servantFinalize on its real
 * finalization time.  Please no resurection or
 * other fancy usage.  <p>
 *
 * This serves as a general replacement for finalize because
 * Ilu forbids clients to use finalize directly.  Clients
 * also must use corba_ServantFinalizer for this to work.
 *
 * @see corba_ServantFinalizer
 */
public interface corba_ServantFinalizable {
    public void servantFinalize() throws Throwable;
}
