/* omg.corba.corba_ServantFinalizer.java */
/* Chris Jacobi, January 7, 1997 2:28 pm PST */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */
 
/* $Id: corba_ServantFinalizer.java,v 1.1 1997/01/07 22:32:57 jacobi Exp $ */
 
package omg.corba;

/**
 * A servant object which wants to take part in the ServantFinalizable
 * "dance" has to call doFinalize in it finalization. <p>
 * Given Ilu's current implementation this is a no-op however; it is
 * provided as it is assumed to be real in other ORBs.
 *
 * @see corba_ServantFinalizable
 */
public class corba_ServantFinalizer {
    public static void doFinalize(corba_ServantFinalizable obj) {
        //If Ilu were a trivial ORB, thats how this procedure would look
        //try {
        //    obj.servantFinalize(); 
        //} catch (Throwable t) {
        //}
    } //doFinalize
} // corba_ServantFinalizer 