/* omg.corba.corba_SystemException.java */
/* Chris Jacobi, December 11, 1996 10:05 pm PST */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */ 
 
/**
 * omg.corba.corba_SystemException
 * - applications may catch this exception 
 * - applications may not throw this exception  
 * - applications may not make direct sub-classes  
 */
 
/*
 * $Id: corba_SystemException.java,v 1.3 1996/12/12 06:32:53 jacobi Exp $
 */

package omg.corba;

public abstract
class corba_SystemException extends xerox.ilu.IluSystemException0 {
    
    /**not public*/
    public corba_SystemException() {
	super();
    }
    /**not public*/
    public corba_SystemException(String s) {
	super(s);
    }
    
    static public final int completedYes = 0;
    static public final int completedNo = 1;
    static public final int completedMaybe = 2;
           
    //  Corba mandated accessors are inherited !
    
}
