/*
Copyright (c) 1991-1995 Xerox Corporation.  All Rights Reserved.  

Unlimited use, reproduction, and distribution of this software is
permitted.  Any copy of this software must include both the above
copyright notice of Xerox Corporation and this paragraph.  Any
distribution of this software must comply with all applicable United
States export control laws.  This software is made available AS IS,
and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
*/
/* $Id: mooring.h,v 1.11 1996/12/13 23:20:17 spreitze Exp $ */
/* Last edited by Mike Spreitzer November 20, 1996 9:16 am PST */


#define mooring_accept(m,peerinfo,dfd,err)\
	((*((m)->mo_accept_connection))(m,peerinfo,dfd,err)))

#define mooring_data(m)			((m)->mo_data)
#define mooring_close(m,dfd,err)	((*((m)->mo_close))(m,dfd,err))
#define mooring_disableWait(m,err)	((*((m)->mo_disableWait))(m,err))
#define mooring_enableWait(m,err)	((*((m)->mo_enableWait))(m,err))
