//  -*- Mode: C++; -*-

// Copyright (c) 1996 Siemens Corporation.  All Rights Reserved.  
//
// Unlimited use, reproduction, and distribution of this software is
// permitted.  Any copy of this software must include both the above
// copyright notice of Siemens Corporation and this paragraph.  Any
// distribution of this software must comply with all applicable United
// States export control laws.  This software is made available AS IS,
// and SIEMENS CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
// INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
// AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
// PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
// THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
// CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
// SIEMENS CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// $Author: bnell $
// $Date: 1996/11/08 19:08:56 $
// $Source: /home/yugo/kwuftn/CVS-repository/ilu-scheme-runtime/iluobj-scm.h,v $
// $Revision: 1.1.1.1 $
//

#ifndef _ILUOBJ_SCM_H_
#define _ILUOBJ_SCM_H_

#include "ilu-type.h"

// for internal use
SCM ilu_object_create_from_registry(ilu_Class c, ilu_Object obj);

// scheme funcs
SCM ilu_object__register_surrogate_creator(SCM _c, SCM _proc);
SCM ilu_object__create_from_registry(SCM _c, SCM _obj);
SCM ilu_object__input_object(SCM _call, SCM disc, SCM pclass);
SCM ilu_object__output_object(SCM _call, SCM _obj, SCM _putative_class);
SCM ilu_object__size_of_object(SCM _call, SCM obj, SCM _putative_class);
SCM ilu_object__lookup(SCM _sid, SCM _ih, SCM _pclass);
SCM ilu_object__register_as_gc_callback(SCM obj);

#endif
