//  -*- Mode: C++; -*-

// Copyright (c) 1996 Siemens Corporation.  All Rights Reserved.  
//
// Unlimited use, reproduction, and distribution of this software is
// permitted.  Any copy of this software must include both the above
// copyright notice of Siemens Corporation and this paragraph.  Any
// distribution of this software must comply with all applicable United
// States export control laws.  This software is made available AS IS,
// and SIEMENS CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
// INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
// AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
// PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
// THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
// CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
// SIEMENS CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
// $Author: bnell $
// $Date: 1996/11/08 19:08:56 $
// $Source: /home/yugo/kwuftn/CVS-repository/ilu-scheme-runtime/ilusrvr-scm.h,v $
// $Revision: 1.1.1.1 $
//

#ifndef _ILUSRVR_SCM_H_
#define _ILUSRVR_SCM_H_

#include "ilu-type.h"

// for internal use
void ilu_server_monitor_conn(ilu_Connection);
ilu_boolean ilu_server_enable_requests(ilu_SCMCall, ilu_Connection);
ilu_boolean ilu_server_disable_requests(ilu_SCMCall, ilu_Connection);

// scheme interface
SCM ilu_server__add_port(SCM _ks, SCM _protocolType, SCM, SCM);
SCM ilu_server__create(SCM _serviceID, SCM _objtab);
SCM ilu_server__id(SCM _ks);

#endif
