(require 'yasyn)

(define pinfo #f)
(define tinfo (vector "sunrpcrm" "tcp_0_0"))
(define do-client #t)
(define mine #f)
(define s #f)
(define sbh #f)

(define-operation (ffib this d n))

(define fib-obj
  (object
   ((ffib this d n ask)
    (let ((f1 0) (f2 0) (ans 1))
      (if (>= n 2)
	  (begin
	    (print "fib(" d ", " n ", 1)")
	    (set! f1 (ffib ask (+ d 1) (- n 1) this))
	    (print "fib(" d ", " n ", 2)")
	    (set! f2 (ffib ask (+ d 1) (- n 2) this))
	    (if (or (not f1) (not f2))
		(set! ans 0)
		(set! ans (+ f1 f2)))))
      (print "fib(" d ", " n ") => " ans)
      ans))
   ))

(define (make-fib) fib-obj)

(define (make-fib2)
  (object-with-ancestors ((fib-obj (make-fib)))
   ((ffib this d n ask) (print "not implemented"))))

(define (make-fib3)
  (object-with-ancestors ((fib-obj (make-fib))))
  )

;(require 'tiny-clos)
;(define <Fibber:T> (make-class (list <object>) (list)))

;(define Calc (make-generic))
;(add-method Calc
;  (make-method (list <Fibber:T>)
;    (lambda (call-next-method Fibber:T d n ask)
;      (let ((f1 0) (f2 0) (ans 1))
;	(if (>= n 2)
;	    (begin
;	      (print "fib(" d ", " n ", 1)")
;	      (set! f1 (Calc ask (+ d 1) (- n 1) Fibber:T))
;	      (print "fib(" d ", " n ", 2)")
;	      (set! f2 (Calc ask (+ d 1) (- n 2) Fibber:T))
;	      (if (or (not f1) (not f2))
;		  (set! ans 0)
;		  (set! ans (+ f1 f2)))))
;	(print "fib(" d ", " n ") => " ans)
;	ans))))

;(define (main n)
;  (let ((peer #f) (ans 0) (mine (make <Fibber:T>)))
;    (set! peer (make <Fibber:T>))
;    (set! ans (Calc peer 1 n mine))
;    (print "Fib(" n ") = " ans)
;    )
;  )
;)

(define (fib d n)
  (let ((f1 0) (f2 0) (ans 1))
    (if (>= n 2)
	(begin
	  (print "fib(" d ", " n ", 1)")
	  (set! f1 (fib (+ d 1) (- n 1)))
	  (print "fib(" d ", " n ", 2)")
	  (set! f2 (fib (+ d 1) (- n 2)))
	  (if (or (not f1) (not f2))
	      (set! ans 0)
	      (set! ans (+ f1 f2)))))
    (print "fib(" d ", " n ") => " ans)
    ans)
  )

(define (main2 n)
  (let ((peer #f) (ans 0))
    (export #f)
    (set! ans (fib 1 n))
    (print "Fib(" n ") = " ans)
    )
  )
