(require 'debug)
(require 'Test1)
(require 'Test2)
(require 'Test3)
(require 'Test1-stubs)
(require 'Test2-stubs)
(require 'Test3-stubs)

;; 923 skips...

;;///////////////////// Test1_T_O1_impl methods /////////////////////

(define Test1:O1-impl-uc #f)
(define Test1:O1-impl-one 0)

(define (make-Test1:O1-impl ih server)
  (let* ((ourInstanceHandle ih)
	 (ourServer server)
	 (obj (object-with-ancestors
	       ((Test1:O1 (make-Test1:O1)))

	       ((get-instance-handle this)
		ourInstanceHandle)
	       ((get-server this)
		ourServer)

	       ((U-CSS-to-U Test1:O1-impl status u css)
		(let ((res #f))
		  (debug:print "Test1.O1.U-CSS-to-U")
		  (set! res u)
		  (set-return-code status Test1:reply-success)
		  res))

	       ((f-CSS-to-RO Test1:O1-impl status css)
		(let ((x (make-Test1:R)))
		  (debug:print "Test1.O1.f-CSS-to-R0")
		  (set-i x 9)
		  (set-css x (Test1:CSS 1 (list "aaa")))
		  (set-a x (make-vector 3))
		  (vector-set! (get-a x) 0 "hi1")
		  (vector-set! (get-a x) 1 "hi2")
		  (vector-set! (get-a x) 2 "hi3")
		  (set-return-code status Test1:reply-success)
		  x))

	       ((R-ScS-to-F Test1:O1-impl status r scs)
		(debug:print "Test1.O1.R-ScS-to-F")
		(set-return-code status Test1:reply-success)
		39.7)

	       ((a-RO Test1:O1-impl status ro)
		(debug:print "Test1.O1.a-RO")
		(set-return-code status Test1:reply-success)
		#t)

	       ((get-O2 Test1:O1-impl status)
		(debug:print "Test1.O1.get-O2")
		(if (not Test1:O1-impl-uc)
		    (set! Test1:O1-impl-uc (make-Test1:O2-impl)))
		(if (not Test1:O1-impl-uc)
		    (set-return-code status Test1:CantCreate)
		    (set-return-code status Test1:reply-success))
		Test1:O1-impl-uc)

	       ((get-O3 Test1:O1-impl status subclass)
		(let ((uc #f))
		  (debug:print "Test1:O1.get-03")
		  (if subclass
		      (set! uc (make-Test3:O-impl))
		      (begin
			(if (= Test1:O1-impl-one 0)
			    (begin
			      (set! Test1:O1-impl-one 1)
			      (debug:print "making O3...")
			      (set! uc (make-Test1:O3-impl)))
			    (begin
			      (set! Test1:O1-impl-one 0)
			      (debug:print "making O4...")
			      (set! uc (make-Test1:O4-impl)))
			    )))
		  (if (not uc)
		      (set-return-code status Test1:CantCreate)
		      (set-return-code status Test1:reply-success))
		  uc))
	       )))
    obj))



;;///////////////////// Test1_T_O2_impl methods /////////////////////

(define (make-Test1:O2-impl)
  (object-with-ancestors
   ((Test1:O2 (make-Test1:O2)))

   ((OO-A0-to-CSS Test1:O2-impl status o a0)
    (debug:print "Test1.o2.OO-A0-to-CSS")
    (if (not o)
	(begin
	  (set-return-code status Test1:E2-exception)
	  (set-status-value status 7)
	  #f)
	(begin
	  (set-return-code status Test1:reply-success)
	  (Test1:CSS 1 (list "xxx"))
	  )
	))

   ((R-I-A1-to-I-A0 Test1:O2-impl status r i a1)
      (debug:print "Test1.O2.R-I-A1-to-I-A0")
      (set-return-code status Test1:reply-success)
      (list i (make-vector 8 #\space)))
   ))

;; ///////////////////// Test1_T_O3_impl methods /////////////////////

(define (make-Test1:O3-impl)
  (object-with-ancestors
   ((Test1:O3 (make-Test1:O3)))

   ((RS-R-to-R-IS Test1:O3-impl status rs r2)
    (let ((is (list)))
      (debug:print "Test1.O3.RS-R-to-R-IS")
      (set! r2 (make-Test1:R))
      (set-i r2 3)
      (set-css r2 (Test1:CSS 1 (list "xxx")))
      (set-a r2 (make-vector 3))
      (vector-set! (get-a r2) 0 "just")
      (vector-set! (get-a r2) 1 "a")
      (vector-set! (get-a r2) 2 "string")
      (list r2 is)))

   ((O1-U-to-U Test1:O3-impl status o u)
    (debug:print "Test1.O3.O1-U-to-U")
    (set-car! u 3)
    (set-cdr! u o)
    (set-return-code status Test1:reply-success)
    (list u #t))

   ((BS-to-I Test1:O3-impl status b)
    (set-return-code status Test1:reply-success)
    (* (length b) (length b))
    )
   ))

;; ///////////////////// Test1_T_P_impl methods /////////////////////

(define (make-Test1:P-impl)
  (object-with-ancestors
   ((Test1:P (make-Test1:P)))

   ((RS-R-to-R-IS Test1:P-impl status rs r2)
    (let ((is (list)))
      (debug:print "Test1.P.RS-R-to-R-IS")
      (set! r2 (make-Test1:R))
      (set-i r2 25179)
      (set-css r2 (Test1:CSS 2 (list "xxx" "yyy")))
      (set-a r2 (make-vector 3))
      (vector-set! (get-a r2) 0 "from")
      (vector-set! (get-a r2) 1 "P")
      (vector-set! (get-a r2) 2 "string")
      (set-return-code status Test1:reply-success)
      (list r2 is)))

   ((O1-U-to-U Test1:P-impl status o u)
    (debug:print "Test1.P.O1-U-to-U")
    (set-car! u 3)
    (set-cdr! u o)
    (set-return-code status Test1:reply-success)
    (list u #t))

   ((BS-to-I Test1:P-impl status b)
    (set-return-code status Test1:reply-success)
    (length b))

   ((m2 Test1:P-impl status j)
    (set-return-code status Test1:reply-success)
    (list j (* j j)))
   ))

;; ///////////////////// Test1_T_O4_impl methods /////////////////////

(define (getb l i)
  (if (>= i (length l)) 0 (list-ref l i)))

(define (make-Test1:O4-impl)
  (object-with-ancestors
   ((Test1:O4 (make-Test1:O4)))

   ((RS-R-to-R-IS Test1:O4-impl status rs r2)
    (let ((is (list)))
      (debug:print "Test1.O4.RS-R-to-R-IS")
      (set! r2 (make-Test1:R))
      (set-i r2 25179)
      (set-css r2 (Test1:CSS 1 (list "xxx")))
      (set-a r2 (make-vector 3))
      (vector-set! (get-a r2) 0 "from")
      (vector-set! (get-a r2) 1 "P")
      (vector-set! (get-a r2) 2 "string")
      (set-return-code status Test1:reply-success)
      (list r2 is)))

   ((O1-U-to-U Test1:O4-impl status o r2)
    (debug:print "Test1.O4.O1-U-to-U")
    (set-car! u 3)
    (set-cdr! u o)
    (set-return-code status Test1:reply-success)
    (list u #t))

   ((BS-to-I Test1:O4-impl status b)
    (debug:print "Test1.O4.BS_to_I (" (length b) ": " (getb b 0) " "
	   (getb b 1) " " (getb b 2) " " (getb b 3) " "
	   (getb b 4) " " (getb b 5) " " (getb b 6) " "
	   (getb b 7) " " (getb b 8) " " (getb b 9) " "
	   (getb b 10) " ...) => " (length b))
    (set-return-code status Test1:reply-success)
    (length b))

   ((R-to-R Test1:O4-impl status r)
    (debug:print "Test1.O4.R_to_R " r " => "  1020304.05060708)
    (set-return-code status Test1:reply-success)
    1020304.05060708)
   ))


;; ///////////////////// Test3_T_O_impl methods /////////////////////

(define (make-Test3:O-impl)
  (object-with-ancestors
   ((Test3:O (make-Test3:O)))

   ((RS-R-to-R-IS Test3:O-impl status rs r2)
    (let ((is (list)))
      (debug:print "Test3.O.RS-R-to-R-IS")
      (set! r2 (make-Test1:R))
      (set-i r2 3)
      (set-css r2 (Test1:CSS 1 (list "xxx")))
      (set-a r2 (make-vector 3))
      (vector-set! (get-a r2) 0 "just")
      (vector-set! (get-a r2) 1 "a")
      (vector-set! (get-a r2) 2 "string")
      (set-return-code status Test1:reply-success)
      (list r2 is)))

   ((O1-U-to-U Test3:O-impl status o u)
    (debug:print "Test3.O.O1-U-to-U(0x" (object-address o) ", {" (car u) "})")
    (set-car! u 3)
    (set-cdr! u o)
    (set-return-code status Test1:reply-success)
    (list u #t))

   ((BS-to-I Test3:O-impl status b)
    (set-return-code status Test1:reply-success)
    (* (length b) (length b)))

   ((SR-to-I Test3:O-impl status i)
    (set-return-code status Test1:reply-success)
    (debug:print "Test3.O.SR-to-I(" i ")");
    (truncate i))

   ((I-to-Test1U Test3:O-impl status i)
    (let ((u (cons 5 #t)))
      (debug:print "Test3.O.I-to-Test1U(" i ")")
      (set-return-code status Test3:reply-success)
      u))
   ))

(define (main argc argv)
  (let* ((s (ilu-server:create "Test1-Server" #f))
	 (uc #f) (uc2 #f))

    (ilu-server:add-port s #f #f #t)
    (ilu:set-default-server s)

    (set! uc (make-Test1:O1-impl "Test1_Initial_Object" s))
    (if (not (publish uc))
	(error "*** Error, could not publish object"))

    ;; test the publish and lookup a bit
    (set! uc2 (ilu-object:lookup "Test1-Server"
				 "Test1_Initial_Object"
				 Test1:TheO1:class-record))

    (if (not (equal? uc2 uc))
	(error "*** Error, lookup returns wrong object"))

    (if (and uc2 (not (publish uc2)))
	(error "*** Error, second publish failed"))

    (if uc
	(begin
	  (debug:print "exported " (string-binding-handle uc))
	  (ilu:run-main-loop 1))
	(error "could not create object"))
    ))
