/* IluDebugStream.java */
/* Chris Jacobi, July 3, 1996 12:54 pm PDT */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */

/* 
 * $Id: IluDebugStream.java,v 1.1 1996/07/12 00:35:16 jacobi Exp $
 */
 
package xerox.ilu;

public class IluDebugStream extends java.io.OutputStream {
    
    public static java.io.PrintStream getIluDebugPrintStream() {
        return new java.io.PrintStream(new IluDebugStream(), true);
    }
    
    public static native void debugWrite1(int b);
    public static native void debugWriteN(byte b[], int off, int len);
    
    public IluDebugStream() {}
    public void write(int b) {
        debugWrite1(b);
    }
    public void write(byte b[], int off, int len) {
        debugWriteN(b, off, len);
    }
    
} // IluDebugStream