/* IluNoObjectException.java */
/* Chris Jacobi, December 12, 1996 12:51 pm PST */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */ 
 
/*
 * $Id: IluNoObjectException.java,v 1.1 1996/12/12 21:31:40 jacobi Exp $
 */

package xerox.ilu;

/**
 * IluNoObjectException.java
 * Ilu raises this in case of an unknown system exception  
 */
public class IluNoObjectException extends omg.corba.corba_UNKNOWN {
    public IluNoObjectException() {
	super();
    }
    public IluNoObjectException(String s) {
	super(s);
    }
}
