/* IluRuntimeException.java */
/* Chris Jacobi, July 3, 1996 12:49 pm PDT */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */
 
/* 
 * $Id: IluRuntimeException.java,v 1.1 1996/07/12 00:49:37 jacobi Exp $ 
 */
 

package xerox.ilu;

/**
 * IluRuntimeException is super class of all IluRuntimeExceptions.
 *
 * RuntimeException's don't need catch phrases.
 *
 * @author      Chris Jacobi
 */
public
class IluRuntimeException extends java.lang.RuntimeException {
    public java.lang.Throwable why = null;
    public IluRuntimeException() {
	super();
    }
    public IluRuntimeException(String s) {
	super(s);
    }
    public IluRuntimeException(java.lang.Throwable why, String s) {
	super(s);
	this.why = why;
    }
}
