/* IluUnexpectedException.java */
/* Chris Jacobi, January 10, 1997 2:31 am PST */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */ 
 
/*
 * $Id: IluUnexpectedException.java,v 1.1 1997/01/10 10:39:04 jacobi Exp $
 */

package xerox.ilu;

/**
 * IluUnexpectedException.java
 * Not client visible  
 */
public class IluUnexpectedException extends IluSomeSystemException {
    /*friendly*/Throwable was = null;
    public IluUnexpectedException(Throwable e) {
	super("IluUnexpectedException");
	was = e;
    }
}
