/* sysmacros_md.ilu <--> sysmacros_md.h */
/* Chris Jacobi, January 31, 1997 11:29 pm PST */

/*
 * Copyright (c) 1996 Xerox Corporation.  All Rights Reserved.  
 * Unlimited use, reproduction, and distribution of this software is
 * permitted.  Any copy of this software must include both the above
 * copyright notice of Xerox Corporation and this paragraph.  Any
 * distribution of this software must comply with all applicable United
 * States export control laws.  This software is made available AS IS,
 * and XEROX CORPORATION DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
 * INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE, AND NOTWITHSTANDING ANY OTHER
 * PROVISION CONTAINED HEREIN, ANY LIABILITY FOR DAMAGES RESULTING FROM
 * THE SOFTWARE OR ITS USE IS EXPRESSLY DISCLAIMED, WHETHER ARISING IN
 * CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, EVEN IF
 * XEROX CORPORATION IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 */

/* $Id: sysmacros_md.h,v 1.2 1997/02/01 07:29:45 jacobi Exp $ */


/* The files sysmacros_md.ilu and sysmacros_md.h are
 * equal. We store both so that users can delete 
 * sysmacros_md.h if they desire and restore it
 * from sysmacros_md.ilu
 */

/* JDK 1.0.2 dependant; it certainly must be removed
 * with JDK 1.1beta2.  Thats easy: JDK 1.1beta2 does have
 * the file.   However its imports are still not missing, but
 * in the wrong directory and must be compensated.
 */ 

 
/*
 *  WARNING
 *  *******
 * 
 *  sys_api.h as we got it here at Xerox, in
 *  /project/java/jdk-1.0.2/include/sys_api.h
 *  has a bug:  It imports sysmacros_md.h
 *  which is not available.  We have made a
 *  a private version of sysmacros_md (This file)
 *  to fix this java bug.  Here at Xerox we do  
 *  not use Sun's version which might be available  
 *  in a source release.
 *
 *  You might notice that this version of sysmacros_md.h
 *  Does not contain a single line from Sun microsystem.
 *
 *  If you are debugging and happen to have legal access to
 *  the real sysmacros_md.h from Sun, we recommend using
 *  the real version instead.  If you are a real company
 *  not willing to work with Sun's mickey mouse public
 *  releases you have to watch whether this substitution
 *  causes any error messages.
 *
 *  At July 11, 1996 I have checked that this substitution 
 *  did not cause any compile time error.
 */

